<template id="alphabetFeed">
    <v-ons-page id="feed1">

        <div class="p-3" v-if="isAndroid()">
            <v-ons-search-input placeholder="Поиск" position="top" v-model="query" class="w-100"></v-ons-search-input>
        </div>

        <div class="flex-buttons px-2">
            <div class="flex-item" v-for="char in 'АӘБВГҒДЕЁЖЗИЙКҚЛМНОПРСТУҰҮФХҺЦЧШЩЫІЭЮЯ'.split('')">
                <button :class="['button', {'active': letter === char }]" @click="letter = char" :aria-label="char">
                    {{ char }}
                </button>
            </div>

            <div class="flex-item">
                <button :class="['button button-primary', {'active': letter === ''}]" @click="letter = ''"
                        aria-label="reset">
                    <v-ons-icon icon="ion-ios-close-circle-outline, material: md-close-circle-o"
                                class="w-100"></v-ons-icon>
                </button>
            </div>
        </div>

        <div class="px-3" v-if="gestures.length">
            <v-ons-list class="my-3">
                <template v-for="(items, letter) in groupedGestures">
                    <v-ons-list-header>{{ letter }}</v-ons-list-header>
                    <v-ons-list-item v-for="(gesture, index) in items" :key="letter + index">
                        <h5 class="item-name">{{ gesture.word }}</h5>


                        <div class="video border-0 video--alphabetical" :data-video="gesture.youtube_url"
                             @click="loadYoutube($event)">
                            <div class="play-button">
                                <v-ons-icon icon="ion-ios-play-circle, material: md-play-circle"></v-ons-icon></div>
                            <img :src="gesture.cover" :alt="gesture.word">
                        </div>

                        <ul class="tags" v-if="gesture.tags">
                            <li class="tags__item" v-for="tag in gesture.tags" @click="selectedTag = tag.id">
                                {{ tag.name }}
                            </li>
                        </ul>

                    </v-ons-list-item>
                </template>
            </v-ons-list>
        </div>
        <div class="m-5 text-center" v-else>
            <template v-if="searched">
                Список пуст
            </template>
        </div>
        <div class="text-center mx-auto" id="progressBar1" v-if="isScrollable">
            <p v-if="!online && gestures.length === 0">
                Нет интернет-подключения
            </p>
            <v-ons-progress-circular indeterminate class="center"></v-ons-progress-circular>
        </div>

    </v-ons-page>
</template>

<script>
    import {_} from 'underscore'

    export default {
        props: ['q'],
        data() {
            return {
                letter: '',
                query: '',
                gestures: [],
                groupedGestures: {},
                selectedTag: '',
                scrolledToBottom: false,
                currentPage: 0,
                lastPage: 0,
                isScrollable: true,
                searched: false,
                online: window.navigator.onLine
            }
        },
        watch: {
            query() {
                this.$emit('changeQuery', this.query)
                this.getGestures('reset');
            },
            letter() {
                this.getGestures('reset');
            },
            q() {
                this.query = this.q
            },
            scrolledToBottom() {
                if (this.scrolledToBottom) {
                    this.getGestures()
                }
            },
            currentPage() {
                if (this.currentPage && this.currentPage === this.lastPage) {
                    this.isScrollable = false
                } else {
                    this.isScrollable = true
                }
            },
            gestures: {
                handler: function (val, oldVal) {
                    this.groupedGestures = _.groupBy(this.gestures, function (item) {
                        return item['word'].charAt(0).toLowerCase();
                    })
                },
                deep: true
            }
        },
        mounted() {
            this.getGestures();
            document.getElementById('feed1').addEventListener('drag', this.onListDrag);
        },
        methods: {
            isAndroid() {
                return this.$ons.platform.isAndroid();
            },
            getGestures(option = '') {
                axios.get(`/api/gestures`, {
                    params: {
                        letter: this.letter,
                        q: this.query,
                        per_page: 15,
                        page: this.currentPage + 1
                    }
                })
                    .then(response => {
                        if (option === 'reset') {
                            this.currentPage = 0
                            this.lastPage = 0
                            this.gestures = response.data.data
                        } else {
                            this.currentPage = response.data.current_page
                            this.lastPage = response.data.last_page
                            this.gestures = this.gestures.concat(response.data.data)
                        }
                    })
                    .then(() => {
                        this.searched = true
                        this.scrolledToBottom = (option === 'reset')
                        this.$emit('gesturesDownloaded')
                    })
                    .catch(e => {
                        console.log('Проверьте интернет-подключение или повторите попытку позже!')
                        this.$ons.notification.alert('Проверьте интернет-подключение или повторите попытку позже!')
                    })
            },
            onListDrag(event) {
                if (this.isScrollable) {
                    let el = document.getElementById('progressBar1')
                    this.scrolledToBottom = this.isInViewport(el)
                }
            },
            isInViewport(elem) {
                let bounding = elem.getBoundingClientRect();
                return (
                    bounding.top >= 0 &&
                    bounding.left >= 0 &&
                    bounding.bottom <= (window.innerHeight || document.documentElement.clientHeight) &&
                    bounding.right <= (window.innerWidth || document.documentElement.clientWidth)
                );
            },
            loadYoutube(event) {
                let iframe = document.createElement("iframe");

                iframe.setAttribute("frameborder", "0");
                iframe.setAttribute("class", "border-0");
                iframe.setAttribute("allowfullscreen", "");
                iframe.setAttribute("src", event.currentTarget.dataset.video + '?rel=0&showinfo=0&autoplay=1');

                event.currentTarget.innerHTML = "";
                event.currentTarget.appendChild(iframe);
            }
        },
    }
</script>
